Update an Agent Observability prompt version

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

PATCH https://api.ap1.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.ap2.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.datadoghq.eu/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.ddog-gov.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.us2.ddog-gov.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.uk1.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.us3.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}https://api.us5.datadoghq.com/api/v2/llm-obs/v1/prompts/{prompt_id}/versions/{version}

Overview

Update the description, the feature-flag environments, or both, for a specific version of an Agent Observability prompt. This endpoint requires all of the following permissions:

  • llm_observability_read
  • llm_observability_write
  • feature_flag_config_read
  • feature_flag_config_write
  • feature_flag_environment_config_read

  • Arguments

    Path Parameters

    Name

    Type

    Description

    prompt_id [required]

    string

    The customer-provided identifier of the Agent Observability prompt.

    version [required]

    integer

    The version number of the Agent Observability prompt.

    Request

    Body Data (required)

    Update prompt version payload.

    Expand All

    Field

    Type

    Description

    data [required]

    object

    Data object for updating an Agent Observability prompt version.

    attributes [required]

    object

    Attributes for updating an Agent Observability prompt version. At least one of description, labels, or env_ids must be provided; all three attributes are optional individually.

    description

    string

    Optional new description for this version.

    env_ids

    [string]

    Optional feature-flag environment UUIDs the service attempts to enable and configure to use this version as their default.

    labels

    [string]

    DEPRECATED: Optional new labels for this version. Do not use this attribute for new integrations.

    type [required]

    enum

    Resource type of an Agent Observability prompt version. Allowed enum values: prompt-template-versions

    {
      "data": {
        "attributes": {
          "description": "string",
          "env_ids": [],
          "labels": []
        },
        "type": "prompt-template-versions"
      }
    }

    Response

    OK

    Response containing a specific version of an Agent Observability prompt.

    Expand All

    Field

    Type

    Description

    data [required]

    object

    Data object for a specific version of an Agent Observability prompt.

    attributes [required]

    object

    Attributes of a specific version of an Agent Observability prompt.

    author

    string

    UUID of the user who authored this version.

    created_at

    date-time

    Timestamp stored on this prompt version.

    datasets

    [object]

    Datasets observed in runs associated with this prompt version.

    id [required]

    string

    Unique identifier of the dataset.

    name

    string

    Name of the dataset.

    description

    string

    Description of this version.

    labels

    [string]

    DEPRECATED: Labels attached to this version (for example development, staging, production).

    last_seen_at

    date-time

    Timestamp of the most recent observed run of this prompt version.

    ml_app

    string

    The ML application this prompt is associated with.

    ml_apps

    [string]

    ML applications observed running this prompt version.

    prompt_id [required]

    string

    Customer-provided identifier of the parent prompt.

    prompt_uuid [required]

    string

    Unique identifier of the parent prompt.

    tags

    [string]

    Tags observed on runs of this prompt version.

    template [required]

     <oneOf>

    A text template or a list of chat messages.

    Object 1

    string

    A text prompt template.

    Object 2

    [object]

    A chat prompt template.

    content [required]

    string

    Content of the message.

    role [required]

    string

    Role of the message (for example system, user, or assistant).

    user_version

    string

    User-supplied identifier for this version.

    version [required]

    int64

    Sequential version number.

    version_created_at

    date-time

    Timestamp when this version was created.

    id [required]

    string

    Unique identifier of the prompt version.

    type [required]

    enum

    Resource type of an Agent Observability prompt version. Allowed enum values: prompt-template-versions

    {
      "data": {
        "attributes": {
          "author": "3b12f1df-14fd-4e12-bd6f-4a2f5c8b3d1e",
          "created_at": "2025-02-01T14:30:00Z",
          "description": "Give concise answers and cite relevant help-center articles.",
          "prompt_id": "customer-support-assistant",
          "prompt_uuid": "4a1a28ff-8a25-5f0f-946f-f48264d772eb",
          "template": [
            {
              "content": "You are a helpful customer support assistant for {{company_name}}.",
              "role": "system"
            },
            {
              "content": "Help {{customer_name}} with this question: {{question}}",
              "role": "user"
            }
          ],
          "version": 2,
          "version_created_at": "2025-02-01T14:30:00Z"
        },
        "id": "d83ab666-61cc-5545-a83b-2424bb85467b",
        "type": "prompt-template-versions"
      }
    }

    Bad Request

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Unauthorized

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Forbidden

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Not Found

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [object]

    A list of errors.

    detail

    string

    A human-readable explanation specific to this occurrence of the error.

    meta

    object

    Non-standard meta-information about the error

    source

    object

    References to the source of the error.

    header

    string

    A string indicating the name of a single request header which caused the error.

    parameter

    string

    A string indicating which URI query parameter caused the error.

    pointer

    string

    A JSON pointer to the value in the request document that caused the error.

    status

    string

    Status code of the response.

    title

    string

    Short human-readable summary of the error.

    {
      "errors": [
        {
          "detail": "Missing required attribute in body",
          "meta": {},
          "source": {
            "header": "Authorization",
            "parameter": "limit",
            "pointer": "/data/attributes/title"
          },
          "status": "400",
          "title": "Bad Request"
        }
      ]
    }

    Too many requests

    API error response.

    Expand All

    Field

    Type

    Description

    errors [required]

    [string]

    A list of errors.

    {
      "errors": [
        "Bad Request"
      ]
    }

    Code Example

                      ## default
    # 
    
    # Path parameters
    export prompt_id="customer-support-assistant"
    export version="1"
    # Curl command
    curl -X PATCH "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/llm-obs/v1/prompts/${prompt_id}/versions/${version}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "description": "Give concise answers and cite relevant help-center articles." }, "type": "prompt-template-versions" } } EOF
    """
    Update an Agent Observability prompt version returns "OK" response
    """
    
    from datadog_api_client import ApiClient, Configuration
    from datadog_api_client.v2.api.agent_observability_api import AgentObservabilityApi
    from datadog_api_client.v2.model.llm_obs_prompt_version_label import LLMObsPromptVersionLabel
    from datadog_api_client.v2.model.llm_obs_prompt_version_type import LLMObsPromptVersionType
    from datadog_api_client.v2.model.llm_obs_update_prompt_version_data import LLMObsUpdatePromptVersionData
    from datadog_api_client.v2.model.llm_obs_update_prompt_version_data_attributes import (
        LLMObsUpdatePromptVersionDataAttributes,
    )
    from datadog_api_client.v2.model.llm_obs_update_prompt_version_request import LLMObsUpdatePromptVersionRequest
    
    body = LLMObsUpdatePromptVersionRequest(
        data=LLMObsUpdatePromptVersionData(
            attributes=LLMObsUpdatePromptVersionDataAttributes(
                env_ids=[],
                labels=[
                    LLMObsPromptVersionLabel.PRODUCTION,
                ],
            ),
            type=LLMObsPromptVersionType.PROMPT_TEMPLATE_VERSIONS,
        ),
    )
    
    configuration = Configuration()
    configuration.unstable_operations["update_llm_obs_prompt_version"] = True
    with ApiClient(configuration) as api_client:
        api_instance = AgentObservabilityApi(api_client)
        response = api_instance.update_llm_obs_prompt_version(prompt_id="prompt_id", version=9223372036854775807, body=body)
    
        print(response)
    

    Instructions

    First install the library and its dependencies and then save the example to example.py and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
    # Update an Agent Observability prompt version returns "OK" response
    
    require "datadog_api_client"
    DatadogAPIClient.configure do |config|
      config.unstable_operations["v2.update_llm_obs_prompt_version".to_sym] = true
    end
    api_instance = DatadogAPIClient::V2::AgentObservabilityAPI.new
    
    body = DatadogAPIClient::V2::LLMObsUpdatePromptVersionRequest.new({
      data: DatadogAPIClient::V2::LLMObsUpdatePromptVersionData.new({
        attributes: DatadogAPIClient::V2::LLMObsUpdatePromptVersionDataAttributes.new({
          env_ids: [],
          labels: [
            DatadogAPIClient::V2::LLMObsPromptVersionLabel::PRODUCTION,
          ],
        }),
        type: DatadogAPIClient::V2::LLMObsPromptVersionType::PROMPT_TEMPLATE_VERSIONS,
      }),
    })
    p api_instance.update_llm_obs_prompt_version("prompt_id", 9223372036854775807, body)
    

    Instructions

    First install the library and its dependencies and then save the example to example.rb and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
    // Update an Agent Observability prompt version returns "OK" response
    
    package main
    
    import (
    	"context"
    	"encoding/json"
    	"fmt"
    	"os"
    
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
    	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
    )
    
    func main() {
    	body := datadogV2.LLMObsUpdatePromptVersionRequest{
    		Data: datadogV2.LLMObsUpdatePromptVersionData{
    			Attributes: datadogV2.LLMObsUpdatePromptVersionDataAttributes{
    				EnvIds: []string{},
    				Labels: []datadogV2.LLMObsPromptVersionLabel{
    					datadogV2.LLMOBSPROMPTVERSIONLABEL_PRODUCTION,
    				},
    			},
    			Type: datadogV2.LLMOBSPROMPTVERSIONTYPE_PROMPT_TEMPLATE_VERSIONS,
    		},
    	}
    	ctx := datadog.NewDefaultContext(context.Background())
    	configuration := datadog.NewConfiguration()
    	configuration.SetUnstableOperationEnabled("v2.UpdateLLMObsPromptVersion", true)
    	apiClient := datadog.NewAPIClient(configuration)
    	api := datadogV2.NewAgentObservabilityApi(apiClient)
    	resp, r, err := api.UpdateLLMObsPromptVersion(ctx, "prompt_id", 9223372036854775807, body)
    
    	if err != nil {
    		fmt.Fprintf(os.Stderr, "Error when calling `AgentObservabilityApi.UpdateLLMObsPromptVersion`: %v\n", err)
    		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
    	}
    
    	responseContent, _ := json.MarshalIndent(resp, "", "  ")
    	fmt.Fprintf(os.Stdout, "Response from `AgentObservabilityApi.UpdateLLMObsPromptVersion`:\n%s\n", responseContent)
    }
    

    Instructions

    First install the library and its dependencies and then save the example to main.go and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
    // Update an Agent Observability prompt version returns "OK" response
    
    import com.datadog.api.client.ApiClient;
    import com.datadog.api.client.ApiException;
    import com.datadog.api.client.v2.api.AgentObservabilityApi;
    import com.datadog.api.client.v2.model.LLMObsPromptVersionLabel;
    import com.datadog.api.client.v2.model.LLMObsPromptVersionResponse;
    import com.datadog.api.client.v2.model.LLMObsPromptVersionType;
    import com.datadog.api.client.v2.model.LLMObsUpdatePromptVersionData;
    import com.datadog.api.client.v2.model.LLMObsUpdatePromptVersionDataAttributes;
    import com.datadog.api.client.v2.model.LLMObsUpdatePromptVersionRequest;
    import java.util.Collections;
    
    public class Example {
      public static void main(String[] args) {
        ApiClient defaultClient = ApiClient.getDefaultApiClient();
        defaultClient.setUnstableOperationEnabled("v2.updateLLMObsPromptVersion", true);
        AgentObservabilityApi apiInstance = new AgentObservabilityApi(defaultClient);
    
        LLMObsUpdatePromptVersionRequest body =
            new LLMObsUpdatePromptVersionRequest()
                .data(
                    new LLMObsUpdatePromptVersionData()
                        .attributes(
                            new LLMObsUpdatePromptVersionDataAttributes()
                                .labels(Collections.singletonList(LLMObsPromptVersionLabel.PRODUCTION)))
                        .type(LLMObsPromptVersionType.PROMPT_TEMPLATE_VERSIONS));
    
        try {
          LLMObsPromptVersionResponse result =
              apiInstance.updateLLMObsPromptVersion("customer-support-assistant", 1L, body);
          System.out.println(result);
        } catch (ApiException e) {
          System.err.println("Exception when calling AgentObservabilityApi#updateLLMObsPromptVersion");
          System.err.println("Status code: " + e.getCode());
          System.err.println("Reason: " + e.getResponseBody());
          System.err.println("Response headers: " + e.getResponseHeaders());
          e.printStackTrace();
        }
      }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to Example.java and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
    // Update an Agent Observability prompt version returns "OK" response
    use datadog_api_client::datadog;
    use datadog_api_client::datadogV2::api_agent_observability::AgentObservabilityAPI;
    use datadog_api_client::datadogV2::model::LLMObsPromptVersionLabel;
    use datadog_api_client::datadogV2::model::LLMObsPromptVersionType;
    use datadog_api_client::datadogV2::model::LLMObsUpdatePromptVersionData;
    use datadog_api_client::datadogV2::model::LLMObsUpdatePromptVersionDataAttributes;
    use datadog_api_client::datadogV2::model::LLMObsUpdatePromptVersionRequest;
    
    #[tokio::main]
    async fn main() {
        let body = LLMObsUpdatePromptVersionRequest::new(LLMObsUpdatePromptVersionData::new(
            LLMObsUpdatePromptVersionDataAttributes::new()
                .env_ids(vec![])
                .labels(vec![LLMObsPromptVersionLabel::PRODUCTION]),
            LLMObsPromptVersionType::PROMPT_TEMPLATE_VERSIONS,
        ));
        let mut configuration = datadog::Configuration::new();
        configuration.set_unstable_operation_enabled("v2.UpdateLLMObsPromptVersion", true);
        let api = AgentObservabilityAPI::with_config(configuration);
        let resp = api
            .update_llm_obs_prompt_version("prompt_id".to_string(), 9223372036854775807, body)
            .await;
        if let Ok(value) = resp {
            println!("{:#?}", value);
        } else {
            println!("{:#?}", resp.unwrap_err());
        }
    }
    

    Instructions

    First install the library and its dependencies and then save the example to src/main.rs and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
    /**
     * Update an Agent Observability prompt version returns "OK" response
     */
    
    import { client, v2 } from "@datadog/datadog-api-client";
    
    const configuration = client.createConfiguration();
    configuration.unstableOperations["v2.updateLLMObsPromptVersion"] = true;
    const apiInstance = new v2.AgentObservabilityApi(configuration);
    
    const params: v2.AgentObservabilityApiUpdateLLMObsPromptVersionRequest = {
      body: {
        data: {
          attributes: {
            envIds: [],
            labels: ["production"],
          },
          type: "prompt-template-versions",
        },
      },
      promptId: "prompt_id",
      version: 9223372036854775807,
    };
    
    apiInstance
      .updateLLMObsPromptVersion(params)
      .then((data: v2.LLMObsPromptVersionResponse) => {
        console.log(
          "API called successfully. Returned data: " + JSON.stringify(data)
        );
      })
      .catch((error: any) => console.error(error));
    

    Instructions

    First install the library and its dependencies and then save the example to example.ts and run following commands:

        
    DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"